/*
 * Copyright (c) 2002 Patrick Tullmann
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this file for any
 * purpose with or without restriction is hereby granted.
 */

public class MemUsage
{
	private class Max
	{
		long k;
		String s;

		Max()
		{
			k=0;
			s="<none>";
		}

	}


	private final long baseUsed;
	private final long baseK;

	private final Max max = new Max();

	public MemUsage()
	{
		System.gc();
		baseUsed = used();
		baseK = baseUsed/1024;
	}

	private long used()
	{
		Runtime r = Runtime.getRuntime();
		return r.totalMemory() - r.freeMemory();
	}

	public void record(String s)
	{
		long u = used()/1024;
		// System.err.println(s+ ": Used=" +u+ "K; delta=" +(u - baseK)+ "K.");

		if (u > max.k)
		{
			max.k = u;
			max.s = s;
		}
	}

	public void report()
	{
		System.err.println("Mem usage max: " +max.k+ "K (" +max.s+ ")");
	}
}

